#include "math.h"
#include "fermattest.h"
#include "extended_euklid.h"
#include "exmod.h"

long test(long a,long b,long c){
     return exmod(a,b,c);
}


class publickey{
      public:
             long e;
             long N;
};
class privatekey{
      public:
             long d;
             long N;
};
class rsa{
      private:
              publickey pukey;
              privatekey prkey;
      public:
             void setpukey(long,long);
             void setprkey(long,long);
             long getepukey(void){return this->pukey.e;};
             long getNpukey(void){return this->pukey.N;};
             long getdprkey(void){return this->prkey.d;};
             long getNprkey(void){return this->prkey.N;};
             void createkeys(void);
             long encrypt(long);
             long decrypt(long);
};
long rsa::encrypt(long val){
     //return (fmodl(powl(val,this->pukey.e),this->pukey.N));
     return exmod(val,this->pukey.e,this->pukey.N);
}
long rsa::decrypt(long val){
     //return (fmodl(powl(val,this->prkey.d),this->prkey.N));
     return exmod(val,this->prkey.d,this->prkey.N);
}
void rsa::setpukey(long en,long Nn){
     this->pukey.e=en;
     this->pukey.N=Nn;
}
void rsa::setprkey(long dn,long Nn){
     this->prkey.d=dn;
     this->prkey.N=Nn;
}

void rsa::createkeys(void){
     long p1,q1,N1,eu1,e1,ggt1,d1,k1;
     Randomize();
     //zwei Primzahlen ermitteln
     p1=random(800)+100;
     while (!fermat(p1)){
           p1=random(800)+100;
     }
     q1=random(800)+100;
     while ((!isprime(p1))||(q1==p1)){
           q1=random(800)+100;
     }
     //RAS Modul berechnen
     N1=p1*q1;
     eu1=(p1-1)*(q1-1);
     e1=eu1;
     while ((fmodl(eu1,e1)==0)||(fmodl(e1,2)==0)||(e1>(p1*q1))){
           e1=random(90)+10;
     }
     //Inverses zu e
     //ggt1,d1,k1=exte(e1,eu1);
     exte2(e1,eu1,ggt1,d1,k1);
     //nur d behalten
     //Werte in die Schlssel einfgen
     this->pukey.e=e1;
     this->pukey.N=N1;
     this->prkey.d=d1;
     this->prkey.N=N1;

}